const app = getApp()
import WxValidate from '../../utils/wxValidate'
const moment = require("../../utils/moment.min")
import { is_show_project } from '../../utils/dict';
import { news_type } from '../../utils/dict';
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '信息管理', leftArrow: true, useBar: false },
        id: '',
        // 图片
        icon: [],
        form: {},
        // 是否使用
        is_showList: is_show_project,
        typeList: news_type,
    },
    initValidate() {
        const rules = { title: { required: true }, type: { required: true }, origin: { required: true }, brief: { required: true }, is_show: { required: true } }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { title: { required: '请输入资讯名称', }, type: { required: '请输入资讯类型', }, origin: { required: '请输入来源', }, brief: { required: '请输入内容' }, is_show: { required: '请选择是否公开' } };
        this.WxValidate = new WxValidate(rules, messages)
    },
    // 返回
    back: function () {
        wx.navigateBack({ delta: 1 })
    },
    //用户输入内容
    inputChange: function (e) {
        const that = this;
        let html = e.detail.html;
        that.setData({ "form.content": html });
    },
    // 选择类型
    typeChange: function (e) {
        const that = this;
        let data = that.data.typeList[e.detail.value];
        if (data) that.setData({ 'form.type': data.value })
    },
    // 是否使用
    is_showChange: function (e) {
        const that = this;
        let data = that.data.is_showList[e.detail.value];
        that.setData({ 'form.is_show': data.value });
    },
    // 上傳圖片
    imgUpload: function (e) {
        const that = this;
        let data = that.data.icon;
        data.push(e.detail)
        that.setData({ icon: data })
    },
    // 删除图片
    imgDel: function (e) {
        const that = this;
        let list = that.data.icon;
        let arr = list.filter((i, index) => index != e.detail.index)
        that.setData({ icon: arr })
    },
    // 提交登录
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        params.create_time = moment().format('YYYY-MM-DD');
        const data = that.data.form;
        params.content = data.content;
        if (!this.WxValidate.checkForm(params)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            let arr;
            if (data._id) {
                if (!params.icon) params.home_url = that.data.icon;
                arr = await app.$post(`/newCourt/api/news/${data._id}`, params);
            }
            else {
                params.home_url = that.data.icon;
                arr = await app.$post(`/newCourt/api/news`, params);
            }
            if (arr.errcode == '0') { wx.showToast({ title: `维护信息完成`, icon: 'success', duration: 2000 }); that.back(); }
            else wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })

        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        that.setData({ id: options.id || '' })
        //验证规则函数
        that.initValidate();
        // 监听用户是否登录
        that.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: async function () {
        const that = this;
        wx.getStorage({
            key: 'user',
            success: async res => {
                if (that.data.id) {
                    const arr = await app.$get(`/newCourt/api/news/${that.data.id}`);
                    if (arr.errcode == '0') {
                        if (arr.data.home_url) that.setData({ icon: arr.data.home_url });
                        that.setData({ form: arr.data });
                    }
                }
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})